<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Fechamento"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="FechamentoIncluidoEvent")]
		[Event(name="FechamentoAtualizadoEvent")]
		[Event(name="FechamentoExcluidoEvent")]
		[Event(name="FechamentoSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.Fechamento;
			
			import br.com.desenv.nepalign.vo.FormaFechamento;
			import br.com.desenv.nepalign.vo.EmpresaFisica;
			import br.com.desenv.nepalign.vo.FormaFechamento;
			// Alguem passa a objeto para ca
			public var fechamento : Fechamento = new Fechamento();
			
			[Bindable]
			private var listaFormaFechamento: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaEmpresaFisica: ArrayCollection = new ArrayCollection();
						
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
// Combo
				ignComboBoxAutoCompleteEmpresaFisica.selectedIndex = -1;
// Combo
				ignComboBoxAutoCompleteFormaFechamento.selectedIndex = -1;
				ignTextInputMovimento.text = "";
				ignTextInputDescricao.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				var remoteObjectFormaFechamento: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("formaFechamentoService", listarFormaFechamentoResultHandler);	
				remoteObjectFormaFechamento.getOperation("listar").send();
				var remoteObjectEmpresaFisica: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaFisicaService", listarEmpresaFisicaResultHandler);	
				remoteObjectEmpresaFisica.getOperation("listar").send();
				var remoteObjectFormaFechamento: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("formaFechamentoService", listarFormaFechamentoResultHandler);	
				remoteObjectFormaFechamento.getOperation("listar").send();
				
				// Se e um novo cadastro
				if (isNaN(this.fechamento.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					//ignComboBoxAutoCompleteEmpresaFisica.selectedItem = this.fechamento.empresaFisica;
					//ignComboBoxAutoCompleteFormaFechamento.selectedItem = this.fechamento.formaFechamento;
					ignTextInputMovimento.text = this.fechamento.movimento;

					ignTextInputDescricao.text = this.fechamento.descricao;

				}
			}
			
			private function listarFormaFechamentoResultHandler( event: ResultEvent ): void 
			{
				listaFormaFechamento = event.result as ArrayCollection;
				listaFormaFechamento.addItemAt(null, 0);
				
				if (this.fechamento != null && this.fechamento.formaFechamento != null)
				{
					for(var i:int = 1; i <= this.listaFormaFechamento.length; i++)
					{
						var formaFechamentoTemp: FormaFechamento = this.listaFormaFechamento.getItemAt(i) as FormaFechamento;
						
						if (formaFechamentoTemp.id == this.fechamento.formaFechamento.id)
						{
							ignComboBoxAutoCompleteFormaFechamento.selectedIndex = i;
							break;
						}
					}
				}	
			}
			private function listarEmpresaFisicaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresaFisica = event.result as ArrayCollection;
				listaEmpresaFisica.addItemAt(null, 0);
				
				if (this.fechamento != null && this.fechamento.empresaFisica != null)
				{
					for(var i:int = 1; i <= this.listaEmpresaFisica.length; i++)
					{
						var empresaFisicaTemp: EmpresaFisica = this.listaEmpresaFisica.getItemAt(i) as EmpresaFisica;
						
						if (empresaFisicaTemp.id == this.fechamento.empresaFisica.id)
						{
							ignComboBoxAutoCompleteEmpresaFisica.selectedIndex = i;
							break;
						}
					}
				}	
			}
				
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(fechamento.id) == false) 
					{
						fechamento.empresaFisica = ignComboBoxAutoCompleteEmpresaFisica.selectedItem; 
						fechamento.formaFechamento = ignComboBoxAutoCompleteFormaFechamento.selectedItem; 
						fechamento.movimento = ignTextInputMovimento.text;
						fechamento.descricao = ignTextInputDescricao.text;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("fechamentoService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(fechamento); 
					// Se e inclusao
					} 
					else 
					{
						fechamento.empresaFisica = ignComboBoxAutoCompleteEmpresaFisica.selectedItem; 
						fechamento.formaFechamento = ignComboBoxAutoCompleteFormaFechamento.selectedItem; 
						fechamento.movimento = ignTextInputMovimento.text;

						fechamento.descricao = ignTextInputDescricao.text;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("fechamentoService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(fechamento); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.fechamento = event.result as Fechamento;
				this.dispatchEvent(new ResultEvent("FechamentoIncluidoEvent",false, true, this.fechamento, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.fechamento = event.result as Fechamento;
				this.dispatchEvent(new Event("FechamentoAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonAdicionarFormaFechamento_clickHandler(event:MouseEvent):void
			{
				var formaFechamentoComponenteCadastro: FormaFechamentoComponenteCadastro = new FormaFechamentoComponenteCadastro();
				formaFechamentoComponenteCadastro.addEventListener("FormaFechamentoIncluidoEvent", atualizarListaFormaFechamentoPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(formaFechamentoComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(formaFechamentoComponenteCadastro);
			}
			
			private function atualizarListaFormaFechamentoPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoFormaFechamento: FormaFechamento = e.result as FormaFechamento;
				listaFormaFechamento.addItem(novoFormaFechamento);
				ignComboBoxAutoCompleteFormaFechamento.selectedItem = novoFormaFechamento;
			}
			protected function buttonAdicionarEmpresaFisica_clickHandler(event:MouseEvent):void
			{
				var empresaFisicaComponenteCadastro: EmpresaFisicaComponenteCadastro = new EmpresaFisicaComponenteCadastro();
				empresaFisicaComponenteCadastro.addEventListener("EmpresaFisicaIncluidoEvent", atualizarListaEmpresaFisicaPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(empresaFisicaComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(empresaFisicaComponenteCadastro);
			}
			
			private function atualizarListaEmpresaFisicaPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoEmpresaFisica: EmpresaFisica = e.result as EmpresaFisica;
				listaEmpresaFisica.addItem(novoEmpresaFisica);
				ignComboBoxAutoCompleteEmpresaFisica.selectedItem = novoEmpresaFisica;
			}
		
			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoFechamento" property="selectedItem" required="true" source="{comboBoxSituacaoFechamento}" trigger="{comboBoxSituacaoFechamento}" triggerEvent="valueCommit"/> -->
		

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Empresa:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEmpresaFisica" styleName="labelValidacao" text="{ignComboBoxAutoCompleteEmpresaFisica.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresaFisica" dataProvider="{listaEmpresaFisica}" labelField="id" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarEmpresaFisica" width="30" label="+" click="buttonAdicionarEmpresaFisica_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Forma Fechamento:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoFormaFechamento" styleName="labelValidacao" text="{ignComboBoxAutoCompleteFormaFechamento.errorString}"/>
					<s:HGroup>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteFormaFechamento" dataProvider="{listaFormaFechamento}" labelField="id" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
						<s:Button id="buttonAdicionarFormaFechamento" width="30" label="+" click="buttonAdicionarFormaFechamento_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>		
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Movimento:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoMovimento" styleName="labelValidacao" text="{ignTextInputMovimento.errorString}"/>
					<visual:IgnTextInput id="ignTextInputMovimento" maxChars="50" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Descrição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricao" styleName="labelValidacao" text="{ignTextInputDescricao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricao" maxChars="50" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>